import './App.css';
import { Redirect, Route, SingleRouter } from './components/SingleRouter/SingleRouter';
import { AppContainer } from './index/index';
import { UploadContainer } from './upload/upload';
import { LogInContainer } from './login/login';
import { ReviewContainer } from './admin/review/review';
import { Component } from 'react';
import { UserContext } from './helper/Context';

class App extends Component {
  constructor(props) {
    super(props);
    this.state = {
      name: '',
      role: -1
    };
    this.setUserData = this.setUserData.bind(this);
  }

  setUserData({ name, role }) {
    this.setState({ name, role });
  }

  render() {
    return (
      <UserContext.Provider value={{ userData: this.state, setUserData: this.setUserData }}>
        <SingleRouter>
          <Route path="/" component={AppContainer} />
          <Route path="/upload" component={UploadContainer} />
          <Route path="/login" component={LogInContainer} />
          <Route path="/admin/review" component={ReviewContainer} />
          <Route component={CheckLogIn} />
        </SingleRouter>
      </UserContext.Provider>
    );
  }
}

function CheckLogIn() {
  return localStorage.getItem('jwt') ? null : <Redirect from={/^\/.*/} to="/login" />;
}

export default App;
